//     Util.js 0.2
//     Copyright(c) 2016, xusimin@itonghui.org
//     js常用工具类
(function() {
	var root = this;
	var _;
	if (typeof root._ === 'function') {
		_ = root._;
	} else {
		_ = function(obj) {
			if (obj instanceof _)
				return obj;
			if (!(this instanceof _))
				return new _(obj);
			this._wrapped = obj;
		};
		root._ = _;
	}
	
	_.VER = 0.4;

	/*返回字符串字节数*/
	_.getBytesLength = function(str) {
		if (typeof str === 'string')
			return str.replace(/[^\x00-\xff]/gi, "--").length;
		else
			return void 0;
	};

	/*去掉数组空元素，包括空字符串*/
	_.removeEmpty = function(arr) {
		try {
			for (var i = arr.length - 1; i >= 0; i--) {
				if (!arr[i]) {
					arr.splice(i, 1);
				}
			}
			return arr;
		} catch (e) {
		}
		return void 0;
	}
	
	/*去掉数组重复项*/
	_.unique = function(arr) {
	    var result = [], hash = {};
	    for (var i = 0, elem; (elem = arr[i]) != null; i++) {
	        if (!hash[elem]) {
	            result.push(elem);
	            hash[elem] = true;
	        }
	    }
	    return result;
	}

	/*获取产品中图路径*/
	_.toMiddleImg = function(src) {
		if (typeof src === 'string' && !!src) {
			return src.substring(0, src.lastIndexOf('.')) + '_middle' + src.substring(src.lastIndexOf('.'));
		}
		return "/undefined";
	}

	/*获取产品小图路径*/
	_.toSmallImg = function(src) {
		if (typeof src === 'string' && !!src) {
			return src.substring(0, src.lastIndexOf('.')) + '_small' + src.substring(src.lastIndexOf('.'));
		}
		return "/undefined";
	}

	/**
	 * js截取字符串，中英文都能用 js截取字符串，中英文都能用；如果给定的字符串大于指定长度，截取指定长度返回，否者返回源字符串；字符串，长度
	 * 
	 * @param str：需要截取的字符串
	 * @param len:
	 *            需要截取的长度
	 */
	_.cutStr = function(str, n) {
		if (!str) {
			return '';
		}
		var strReg = /[^\x00-\xff]/g;
		var _str = str.replace(strReg, "**");
		var _len = _str.length;
		if (_len > n) {
			var _newLen = Math.floor(n / 2);
			var _strLen = str.length;
			for (var i = _newLen; i < _strLen; i++) {
				var _newStr = str.substr(0, i).replace(strReg, "**");
				if (_newStr.length >= n) {
					str = str.substr(0, i) + "...";
					break;
				}
			}
		}
		return str;
	}
	
	/*乘法*/
	_.accMul = function(arg1, arg2) {
		var m = 0, s1 = arg1.toString(), s2 = arg2.toString();
		try {m += s1.split(".")[1].length} catch (e) {}
		try {m += s2.split(".")[1].length} catch (e) {}
		return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
	}

	/*获取UUID*/
	_.uuid = function(){
		var uuid = [];
		var hexDigits = "0123456789abcdef";
		for (var i = 0; i < 36; i++) {
			uuid[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
		}
		uuid[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
		uuid[19] = hexDigits.substr((uuid[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
		uuid[8] = uuid[13] = uuid[18] = uuid[23] = "-";
		return uuid.join("");
	}
	
	var xssMap = {
		unescapeXSS: {
			'＞': '>',
			'＜': '<',
			"‘": '\'',
			"’": '\'',
			'“': '"',
			'”': '"',
			'＼': '\\',
			'％': '%'
		}
	};
	var entityXssRegexes = {
		unescapeXSS: new RegExp('[＞＜‘’“”＼％]', 'g')
	};
	/*全角字符转成半角字符*/
	_.unescapeXSS = function(string) {
		if (string == null) return '';
		return ('' + string).replace(entityXssRegexes['unescapeXSS'], function(match) {
			return xssMap['unescapeXSS'][match];
		});
	}
	
	/*获取url传递参数*/
	_.getRequest = function () {
		var url = window.location.search; //获取url中"?"符后的字串
		var theRequest = new Object();
		if (url.indexOf("?") != -1) {
			var str = url.substr(1);
			strs = str.split("&");
			for(var i = 0; i < strs.length; i ++) {
				var strss = strs[i];
				if(strss) {
					theRequest[strss.split("=")[0]]=(strss.split("=")[1]);
				}
			}
		}
		return theRequest;
	}
	
	/*根据参数名获取url传递参数*/
	_.getRequestByName = function (name) { 
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i"); 
		var r = window.location.search.substr(1).match(reg); 
		if (r != null) return unescape(r[2]); return null; 
	}
	
	/*去除字符串两头空格*/
	_.trimStr = function (string) {
		if(typeof string === 'string'){
			return string.replace(/(^\s*)|(\s*$)/g,"");
		}
		return string;
	}
	
	/*判断是否以字符串结尾*/
	_.endWith = function(string, str){
		var pos = string.lastIndexOf(str);
	    if(pos === -1){
	        return false;
	    }else{
	        return pos + str.length === string.length;
	    }
	}
	
	/*加载JS/CSS文件*/
	var file = [];
	_.load = function(src) {
		if(typeof src === 'string') {
			var l = file.length;file.push(src),file=_.unique(_.removeEmpty(file));
			if(l < file.length) {
				if(_.endWith(src, '.js')) {
					document.head.appendChild(function() {
						var a = document.createElement("script");
						return a.src = src, a.type = "text/javascript", a;
					}());
				} else if(_.endWith(src, '.css')) {
					document.head.appendChild(function() {
						var a = document.createElement("link");
						return a.href = src, a.type = "text/css", a.rel = "styleSheet", a;
					}());
				}
			}
		}
	}
	
	/*存Cookie的值*/
	_.setCookie = function(name,value,minute) { 
		var expires = -1;
		if(minute) {
			var exp = new Date(); 
			exp.setTime(exp.getTime() + minute*60*1000); 
			expires = exp.toGMTString();
		}
		document.cookie = name + "="+ escape (value) + ";expires=" + expires;
	}
	/*取Cookie的值*/
	_.getCookie = function(name) { 
		var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
		if(arr=document.cookie.match(reg))
			return unescape(arr[2]); 
		else 
			return null; 
	}
	/*删除Cookie的值*/
	_.delCookie = function(name) { 
	    var exp = new Date(); 
	    exp.setTime(exp.getTime() - 1); 
	    var cval=_.getCookie(name); 
	    if(cval!=null) 
	        document.cookie= name + "="+cval+";expires="+exp.toGMTString(); 
	} 
	
	/*数字格式化为金额格式*/
	_.fmoney = function(s, n) {  
		n = n > 0 && n <= 20 ? n : 2;  
		s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";  
		var l = s.split(".")[0].split("").reverse(),  
		r = s.split(".")[1];  
		t = "";  
		for(i = 0; i < l.length; i ++ ) {  
			t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");  
		}  
		return t.split("").reverse().join("") + "." + r;  
	}
	_.fshortmoney = function(number) {
		if (number < 10000) {
			return _.fmoney(number) + '元';
		} else if (number < 100000000) {
			return _.fmoney(number / 10000) + '万元';
		} else {
			return _.fmoney(number / 100000000) + '亿元';
		}
	}
	/*金额格式化为数字格式*/
	_.fnumber = function(money) {
		return parseFloat(money.replace(/,/g,''));
	}
	
	/*
	** randomWord 产生任意长度随机字母数字组合
	** randomFlag-是否任意长度 min-任意长度最小位[固定位数] max-任意长度最大位
	** xuanfeng 2014-08-28
	*/
	 
	_.randomWord = function(randomFlag, min, max){
	    var str = "",
	        range = min,
	        arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
	 
	    // 随机产生
	    if(randomFlag){
	        range = Math.round(Math.random() * (max-min)) + min;
	    }
	    for(var i=0; i<range; i++){
	        pos = Math.round(Math.random() * (arr.length-1));
	        str += arr[pos];
	    }
	    return str;
	}
	
	/*
	 * 对象数组排序比较器
	 * eg:	array.sort(_.by('number'))
	 * desc:true 降序; false 升序
	 */
	_.by = function(name,desc) {
		return function(o, p) {
			var a, b;
			if (typeof o === "object" && typeof p === "object" && o && p) {
				a = o[name];
				b = p[name];
				if(a==null)a=0;
				if(b==null)b=0;
				if (a === b) {
					return 0;
				}
				if (typeof a === typeof b) {
					if (desc) {
						return a < b ? -1 : 1;
					} else {
						return a > b ? -1 : 1;
					}
				}
				if (desc) {
					return typeof a < typeof b ? -1 : 1;
				} else {
					return typeof a > typeof b ? -1 : 1;
				}
			}
			else {
				throw ("error");
			}
		}
	}
}).call(this);