﻿/******************************************************
 * 常用方法(页面跳转,拨打电话,发送短信)，必须引用app.js****
 * ****************************************************
 * ***************************************************/

(function(w) {
	/********************页面跳转(示例)*********************
	 * html标签使用***************************************** 
	 * <a href="eventList.html" class="openWindow" data-name="eventList">
	 * js使用************************************plusReady*********
	 * openWindow('html_home[首页]/eventList.html',{name:'eventList'});
	 * ***************************************************/

	/*
	 *打开页面 
	 */
	w.openWindow = function(href, data) {
		if(app.isLogin() && !checkMenu(href)){
			mui.toast('暂无权限！');
			return;
		}
		console.log('page id: ' + href + " " + (JSON.stringify(data)));
		mui.openWindow({
			url: href,
			id: href,
			extras: data,
			createNew: true,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'pop-in', //页面显示动画，默认为”slide-in-right“；
				event: 'loaded', //页面显示时机，默认为titleUpdate事件时显示
				extras: {} //窗口动画是否使用图片加速
			},
		});
	}

	//打开新页面并关闭其余所有页面
	w.openNewCloseOther=function(href,data){
		// 获取所有Webview窗口
		var wvs=plus.webview.all();
		w.openWindow(href,data);
		setTimeout(function(){
			for(var i=0;i<wvs.length;i++){
				console.log('webview'+i+': '+wvs[i].getURL());
				wvs[i].close('none', 0)
			}
		},1500);
	}
	
	w.checkMenu = function(href){//判断操作权限，href传目标页面路径，此方法给本js使用
		var menus = app.getInfo().menus;
		var allauths = app.getInfo().allauths;
		var url = href.substring(href.lastIndexOf('/')+1);
		if(allauths.indexOf(url) >= 0){
			if(menus.indexOf(url) >= 0){
				return true;
			}else{
				return false;
			}
		}
		return true;
	}
	w.checkPermission = function(code){//判断操作权限，code传操作编码，此方法给页面操作调用
		var permissions = app.getInfo().permissions;
		if(permissions.indexOf(code)){
			return true;
		}
		return false;
	}
	w.initMenu = function(){//此方法给采购商和供应商的个人中心使用，判断菜单的显示隐藏
		$('body').find('.checkMenuBox').each(function(){
			var haveAny = false;
			$(this).find(".openWindow").each(function(){
				if(!checkMenu($(this).attr('href'))){
					$(this).hide();
				}else{
					$(this).show();
					haveAny = true;
				}
			})
			if(!haveAny){
				$(this).hide();
			}else{
				$(this).show();
			}
		})
	}
	w.adjustNavBar = function(){
		
	}

	mui('body').on('tap', '.openWindow', function() {
		var href = $(this).attr('href');
		if(href) w.openWindow(href, $(this).data());
	})

	//拨打电话
	mui('body').on('tap', '.openTel', function() {
		var tel = this.getAttribute('data-tel')
		if(!tel) return;
		if(mui.os.plus) {
			plus.device.dial(this.getAttribute('data-tel'), true);
		} else {
			window.location.href = 'tel:' + this.getAttribute('data-tel');
		}
	})

	//发送短信
	mui('body').on('tap', '.openSms', function() {
		plus.runtime.openURL('sms:' + this.getAttribute('data-sms'));
	})

	//发送邮件
	mui('body').on('tap', '.openMail', function() {
		plus.runtime.openURL('mailto:' + this.getAttribute('data-mail'));
	})

	//截取字符串
	w.subText = function(text, index) {
		if(text && text.length > index) text = text.substring(0, index);
		return text;
	}

	//数据转换为保留两位小数
	w.floatTurn = function(val) {
		var result = '0.00';
		if(!val) return result;
		result = parseFloat(val).toFixed(2);
		return result;
	}

	//数据转换为保留整数
	w.integerTurn = function(val) {
		var result = '0';
		if(!val) return result;
		result = parseFloat(val).toFixed(0);
		return result;
	}

	//去空
	w.delEmpty = function(text) {
		if(!text || text == null || text == undefined) return '';
		return text;
	}
	
	//格式化HTML文本，统一给img添加前缀
	w.checkImgSrc= function(str) {
		var html = $(str);
		html.find('img').each(function() {
			var src = $(this).attr('src');
			if(typeof src === 'string' && src.substring(0, 1) == '/') {
				$(this).attr('src', BASEURL + src);
			}
		})
		return html;
	}

	//格式化时间戳 xxxx-xx-xx xx:xx:xx
	w.formatDateTime = function(inputTime) {
		if(inputTime == "") {
			return "--";
		}
		var date = new Date(inputTime);
		var y = date.getFullYear();
		var m = date.getMonth() + 1;
		m = m < 10 ? ('0' + m) : m;
		var d = date.getDate();
		d = d < 10 ? ('0' + d) : d;
		var h = date.getHours();
		h = h < 10 ? ('0' + h) : h;
		var minute = date.getMinutes();
		var second = date.getSeconds();
		minute = minute < 10 ? ('0' + minute) : minute;
		second = second < 10 ? ('0' + second) : second;
		return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
	};

	//格式化时间戳 xxxx-xx-xx
	w.formatDate = function(inputTime) {
		if(inputTime == "" || inputTime == undefined) {
			return "--";
		}
		var date = new Date(inputTime);
		var y = date.getFullYear();
		var m = date.getMonth() + 1;
		m = m < 10 ? ('0' + m) : m;
		var d = date.getDate();
		d = d < 10 ? ('0' + d) : d;
		var h = date.getHours();
		h = h < 10 ? ('0' + h) : h;
		return y + '-' + m + '-' + d;
	};

	//格式户撒时间字符串xxxx-xx-xx
	w.formatDateStr = function(inputTime) {
		if(inputTime == "") {
			return "--";
		}
		var inputtime = inputTime.replace(/\-/g, "/");
		var date = new Date(inputtime);
		var y = date.getFullYear();
		var m = date.getMonth() + 1;
		m = m < 10 ? ('0' + m) : m;
		var d = date.getDate();
		d = d < 10 ? ('0' + d) : d;
		var h = date.getHours();
		h = h < 10 ? ('0' + h) : h;
		return y + '-' + m + '-' + d;
	}

	/*乘法*/
	w.accMul = function(arg1, arg2) {
		var m = 0,
			s1 = arg1.toString(),
			s2 = arg2.toString();
		try {
			m += s1.split(".")[1].length
		} catch(e) {}
		try {
			m += s2.split(".")[1].length
		} catch(e) {}
		return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
	}

	//返回到根视图
	w.returnToRoot = function() {
		var all = plus.webview.all(); //获取所有的webview窗口
		var current = plus.webview.currentWebview(); //获取当前窗口的webviewObject对象
		var mainArr = ['tab_home.html', 'tab_cart.html', 'tab_center.html', '../buyer/tab/index.html', current.id];
		for(var i = 0; i < all.length; i++) {
			if($.inArray(all[i].id, mainArr) < 0) all[i].close('none', 0);
		}
	}

	w.channelBack = function() {
		if(mui.os.plus){
			if(mui.os.ios) {
				//禁用ios从屏幕边缘右滑关闭
				var self = plus.webview.currentWebview();
				self.setStyle({
					'popGesture': 'none'
				});
			} else {
				//处理逻辑：1秒内，连续两次按返回键，则退出应用；
				var first = null;
				mui.back = function() {
					//首次按键，提示‘再按一次退出应用’
					if(!first) {
						first = new Date().getTime();
						mui.toast('再按一次退出应用');
						setTimeout(function() {
							first = null;
						}, 1000);
					} else {
						if(new Date().getTime() - first < 1000) {
							plus.runtime.quit();
						}
					}
				};
			}
		}
	}

	// 处理返回事件
	var ws;
	w.back = function(hide) {
		if(w.plus) {
			ws || (ws = plus.webview.currentWebview());
			if(hide || ws.preate) {
				ws.hide('auto');
			} else ws.close('auto');
		} else if(history.length > 1) {
			history.back();
		} else w.close();
	};
	w.checkblur = function(hide) {
		$("input[type = 'text']").blur(); 
		$("input[type = 'tel']").blur(); 
		$("input[type = 'password']").blur(); 
		$("input[type = 'number']").blur();
		$("select").blur();
		$("textarea").blur(); 
	}
})(window);
