
/**
 * Handlebars自定义helper
 */
(function(Handlebars) {
	//全局对象，命名空间
	var object = new Object();
	
	Handlebars.registerHelper({
		/**  是否有权限 */
		havePermission: function(perm,options){
			if(permission.havePermission(perm)){
				return options.fn(this);
			}
		},
		/** 如果等于 */
		ifEqual: function(value,num,options) {
			if(value == num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/** 如果等于 */
		ifDoubleEqual: function(a1,a2,b1,b2,options) {
			if((a1 == a2) && (b1 == b2)) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/** 如果不等于 */
		ifNotEqual: function(value,num,options) {
			if(value != num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/**
		 * 如果小于
		 */
		ifLess: function(index,num,options) {
			if(index < num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/**
		 * 如果大于
		 */
		ifGreater: function(index,num,options) {
			if(index > num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/**
		 * 如果大于等于
		 */
		ifGreaterOrEqual: function(index,num,options) {
			if(index > num || index == num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		
		/**
		 * 如果小于等于
		 */
		ifLessOrEqual: function(index,num,options) {
			if(index < num || index == num) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/**
		 * 加
		 */
		plus: function(index,num) {
			return index + num;
		},
		/**
		 * 减
		 */
		minus: function(index,num) {
			return index - num;
		},
		/**
		 * 乘
		 */
		multip:function(index,num) {
			return _.accMul(index,num);
		},
		/**
		 * 除
		 */
		division: function(index,num) {
			return index / num;
		},
		/**
		 * 保留小数位
		 */
		toFixed: function(index,num) {
			if(!!index) {
				return index.toFixed(num);
			}else {
				return '暂无价格信息';
			}
		},
		/**
		 * 如果整除
		 */
		ifDivisible: function(index,num,options) {
			if(index % num == 0) {
				return options.fn(this);
			} else {
				return options.inverse(this);
			}
		},
		/**
		 * 日期格式化
		 */
		dateFormat: function(time,fmt) {
			if (!time) {
				return '';
			} else if (time == 'now') {
				return moment().format(fmt);
			}
			return moment(time).format(fmt);
		},
		/**
		 * 截取字符串
		 */
		cutStr: function(str, n){
			return _.cutStr(str, n);
		},
		/**
		 * 截取字符串
		 */
		substring: function(str, start, end) {
			if (!str) {
				return '';
			}
			return str.substring(start,end);
		},
		/**
		 * 全角字符转成半角字符
		 */
		unescapeXSS:function(str) {
			return _.unescapeXSS(str);
		},
		/**
		 * 填充字符
		 */
		fillLeft: function(source,fillChar,length) {
			return _.fillLeft(source,fillChar,length);
		},
		/**
		 * 全局唯一的id
		 */
		uniqueId: function(perfix) {
			if (perfix) {
				object.uniqueId = _.uniqueId(perfix);
			} else {
				object.uniqueId = _.uniqueId();
			}
			return object.uniqueId;
		},
		lastUniqueId: function() {
			return object.uniqueId;
		},
		
		URL: function() {
			return URL;
		}
	})
	
	
})(Handlebars)