/******************************************************
 * 输入框限制*******************************************
 * ****************************************************
 * ***************************************************/

//表情限制
function checkEmoji(obj) {
	if(obj.value != obj.value.replace(/[\ud800-\udbff][\udc00-\udfff]/g, '')) {
		obj.value = obj.value.replace(/[\ud800-\udbff][\udc00-\udfff]/g, '');
	}
}
//只能输入数字和字母
function checkA_Z0_9(obj) {
	if(obj.value != obj.value.replace(/\s/)) {
		return;
	} else if(obj.value != obj.value.replace(/[^\A-Za-z0-9\/]/ig, '')) {
		obj.value = obj.value.replace(/[^\A-Za-z0-9\/]/ig, '');
	}
}

//只能输入英文字母
function onlyEnglish(obj) {
	if(obj.value != obj.value.replace(/\s/)) {
		return;
	} else if(obj.value != obj.value.replace(/[^\A-Za-z\/]/ig, '')) {
		obj.value = obj.value.replace(/[^\A-Za-z\/]/ig, '');
	}
}

//只能输入中文
function onlyChinese(obj) {
	if(obj.value != obj.value.replace(/\s/)) {
		return;
	} else if(obj.value != obj.value.replace(/[^\u4e00-\u9fa5]*$/ig, '')) {
		obj.value = obj.value.replace(/[^\u4e00-\u9fa5]*$/ig, '');
	}
}
/**文本框，只可输入小于1的小数**/
function clearNoNum(obj) {
	obj.value = obj.value.replace(/[^\d.]/g, "");
	obj.value = obj.value.replace(/^\./g, "");
	obj.value = obj.value.replace(/\.{2,}/g, ".");
	obj.value = obj.value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
	if(isNaN(obj.value)) {
		alert("请输入有效数字");
		return false;
	}
	//保留小数点后两位
	if(obj.value.indexOf('.') != -1 && obj.value.split('.')[1].length > 2) {
		obj.value = obj.value.split('.')[0] + '.' + obj.value.split('.')[1].substring(0, 2);
	}
	//.前面的数值不可超过1
	if(obj.value.length > 0) {
		if(obj.value.indexOf('0') != 0) {
			obj.value = "";
		} else if(obj.value.length > 1) {
			if(obj.value.substring(1, 2) != ".") {
				obj.value = "0";
			}
		}
	}
}
/**文本框，只可输入小数，小数点后最多两位**/
function checkNoNum(obj) {
	if(obj.value == '' || parseFloat(obj.value) == 0) {
		//		obj.value = '1';
		return;
	}
	obj.value = obj.value.replace(/[^\d.]/g, "");
	obj.value = obj.value.replace(/^\./g, "");
	obj.value = obj.value.replace(/\.{2,}/g, ".");
	obj.value = obj.value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
	if(obj.value.indexOf('.') != -1 && obj.value.split('.')[1].length > 2) {
		obj.value = obj.value.split('.')[0] + '.' + obj.value.split('.')[1].substring(0, 2);
	}
}
/**文本框，只可输入小数，小数点后最多三位**/
function checkNoNumThree(obj) {
	obj.value = obj.value.replace(/[^\d.]/g, "");
	obj.value = obj.value.replace(/^\./g, "");
	obj.value = obj.value.replace(/\.{2,}/g, ".");
	obj.value = obj.value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
	if(obj.value.indexOf('.') != -1 && obj.value.split('.')[1].length > 3) {
		obj.value = obj.value.split('.')[0] + '.' + obj.value.split('.')[1].substring(0, 3);
	}
}

/*只能输入整数*/
function onlyNum(obj) {
	if(obj.value != obj.value.replace(/\D/gi, '')) {
		obj.value = obj.value.replace(/\D/gi, '');
	}
}

/*数字&&必填&&大于0*/
function onlyNumMust(obj) {
	if(obj.value == '' || obj.value == '0') {
		obj.value = '1';
	}
}

//限制纯数字并限制最大数据
function onlyNumWithMax(obj, level) {
	if(obj.value != obj.value.replace(/\D/gi, '')) {
		obj.value = obj.value.replace(/\D/gi, '');
	}
	if(parseInt(obj.value) > level) {
		obj.value = level;
	}
}

