$(function() {
	var uploadArr = $(".uploadImage");
	$.each(uploadArr, function() {
		var _this = $(this);
		listenFunc(this);
	});

	function listenFunc(obj) {
		if(mui.os.plus) {
			obj.addEventListener('tap', function() {
				var uploadTitle = $(this).attr('title');
				var a = [{
					title: "拍照"
				}, {
					title: "从手机相册选择"
				}];
				plus.nativeUI.actionSheet({
					title: uploadTitle,
					cancel: "取消",
					buttons: a
				}, function(b) { /*actionSheet 按钮点击事件*/
					switch(b.index) {
						case 0:
							break;
						case 1:
							getImage(obj); /*拍照*/
							break;
						case 2:
							galleryImg(obj); /*打开相册*/
							break;
						default:
							break;
					}
				})
			});
		}
	}

	function getImage(obj) {
		var c = plus.camera.getCamera();
		c.captureImage(function(e) {
			plus.io.resolveLocalFileSystemURL(e, function(entry) {
				var s = entry.toLocalURL() + "?version=" + new Date().getTime();
				uploadHead(s, obj); /*上传图片*/
			}, function(e) {
				console.log("读取拍照文件错误：" + e.message);
			});
		}, function(s) {
			console.log("error" + s);
		}, {
			filename: "_doc/head.png"
		})
	}

	//本地相册选择
	function galleryImg(obj) {
		plus.gallery.pick(function(a) {
			plus.io.resolveLocalFileSystemURL(a, function(entry) {
				plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
					root.getFile("head.png", {}, function(file) {
						//文件已存在
						file.remove(function() {
							console.log("file remove success");
							entry.copyTo(root, 'head.png', function(e) {
									var e = e.fullPath + "?version=" + new Date().getTime();
									uploadHead(e, obj); /*上传图片*/
									//变更大图预览的src
									//目前仅有一张图片，暂时如此处理，后续需要通过标准组件实现
								},
								function(e) {
									console.log('copy image fail:' + e.message);
								});
						}, function() {
							console.log("delete image fail:" + e.message);
						});
					}, function() {
						//文件不存在
						entry.copyTo(root, 'head.png', function(e) {
								var path = e.fullPath + "?version=" + new Date().getTime();
								uploadHead(path, ''); /*上传图片*/
							},
							function(e) {
								console.log('copy image fail:' + e.message);
							});
					});
				}, function(e) {
					console.log("get _www folder fail");
				})
			}, function(e) {
				console.log("读取拍照文件错误：" + e.message);
			});
		}, function(a) {}, {
			filter: "image"
		})
	};

	//上传图片
	function uploadHead(imgPath, obj) {
		//console.log("imgPath = " + imgPath);
		var mainImage = obj;
		mainImage.src = imgPath;
		mainImage.style.width = "66px";
		mainImage.style.height = "66px";

		var image = new Image();
		image.src = imgPath;
		image.onload = function() {
			var imgData = getBase64Image(image);
			imgupgrade(imgData);
			/*在这里调用上传接口*/
			// mui.ajax("图片上传接口", {
			// data: {
			//
			// },
			// dataType: 'json',
			// type: 'post',
			// timeout: 10000,
			// success: function(data) {
			// console.log('上传成功');
			// },
			// error: function(xhr, type, errorThrown) {
			// mui.toast('网络异常，请稍后再试！');
			// }
			// });
		}
	}
	//将图片压缩转成base64
	function getBase64Image(img) {
		var canvas = document.createElement("canvas");
		var width = img.width;
		var height = img.height;
		// calculate the width and height, constraining the proportions
		if(width > height) {
			if(width > 500) {
				height = Math.round(height *= 500 / width);
				width = 500;
			}
		} else {
			if(height > 500) {
				width = Math.round(width *= 500 / height);
				height = 500;
			}
		}
		canvas.width = width; /*设置新的图片的宽度*/
		canvas.height = height; /*设置新的图片的长度*/
		var ctx = canvas.getContext("2d");
		ctx.drawImage(img, 0, 0, width, height); /*绘图*/
		var dataURL = canvas.toDataURL("image/png", 0.8);
		return dataURL.replace("data:image/png;base64,", "");
	}

	function imgupgrade(imgData) {
		var attachId = $('#attachId').val();
		net.ajax('/wechat/attachmgr/uploadcredentials?uploadType=15&fileType=0', {
			showErrorMsg: false,
			data: {
				files1: imgData,
				attachRootId: attachId
			}, // 参数名称
			success: function(msg) {
				if(msg.statusCode == 200) {
					var html = '<div class="img-goods fl">';
					html += '<span class="remove-goods font_8">x</span>';
					html += '<img src="' + BASEURL + msg.obj + '"  data-preview-src="" data-preview-group="1" style="width:103.5px;height:88px;"/>';
					html += '</div>';
					mui.toast("上传成功");
					var num = $(".img-goods").length;
					if(num == 0) {
						$('.mui-clearfix').find('a').eq(0).before(html);
					} else {
						$('.mui-clearfix').find('div').eq(0).before(html);
						$('.imghide').hide();
					}
				}
			},
			error: function(msg) {
				alert('上传出错');
			}
		});
	}
})